## rnp 0.16.0

=== CMakeLists.txt ===
# Copyright (c) 2018-2020 Ribose Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

# 3.7+ for the BZip2 target in the cmake-bundled finder (basic build)
# 3.8+ for CPACK_RPM_MAIN_COMPONENT (RPM packaging)
# 3.10+ for CPackFreeBSD (FreeBSD packaging)
# 3.10+ for gtest_discover_tests (parallel rnp_tests)
# 3.12+ for NAMELINK_COMPONENT (for better RPM packaging)
# 3.12+ for Python3 find module
# 3.14+ for object library link dependency propagation
cmake_minimum_required(VERSION 3.14)

# contact email, other info
include(cmake/info.cmake)

# determine version
if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmake/version.cmake")
  file(DOWNLOAD https://raw.githubusercontent.com/rnpgp/cmake-versioning/main/version.cmake
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/version.cmake")
endif()
include(cmake/version.cmake)
determine_version("${CMAKE_CURRENT_SOURCE_DIR}" RNP)

# project name, etc
project(RNP
  VERSION "${RNP_VERSION}"
  LANGUAGES C CXX
  DESCRIPTION "${PACKAGE_DESCRIPTION_SHORT}"
)

# options
option(ENABLE_COVERAGE "Enable code coverage testing.")
option(ENABLE_SANITIZERS "Enable ASan and other sanitizers.")
option(ENABLE_FUZZERS "Enable fuzz targets.")
option(DOWNLOAD_GTEST "Download Googletest" On)
option(DOWNLOAD_RUBYRNP "Download ruby-rnp and run related tests." On)
# crypto components
option(ENABLE_SM2 "Enable SM2/SM3/SM4 algorithms support." On)
option(ENABLE_AEAD "Enable AEAD ciphers support." On)
option(ENABLE_TWOFISH "Enable Twofish cipher support." On)
option(ENABLE_BRAINPOOL "Enable Brainpool curves support." On)

# tri-state options
set(TRISTATE_VALUES On Off Auto)

set(ENABLE_DOC Auto CACHE STRING "Enable building documentation.")
set_property(CACHE ENABLE_DOC PROPERTY STRINGS ${TRISTATE_VALUES})

# so we can use our bundled finders
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/Modules")

# required modules
include(CTest)

# default to a release build
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Build type. Options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE
  )
endif()

# crypto backend
if (NOT CRYPTO_BACKEND)
  set(CRYPTO_BACKEND "botan" CACHE STRING
    "Crypto backend. Possible values are botan and openssl (under development, only for debug builds). Default is botan."
    FORCE
  )
endif()
if(CRYPTO_BACKEND STREQUAL "botan")
  # Default value;
  set(CRYPTO_BACKEND_BOTAN 1)
elseif(CRYPTO_BACKEND STREQUAL "openssl")
  # Do not allow OpenSSL backend in release builds yet.
  if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
    message(WARNING "OpenSSL backend should be used only at debug mode and not ready for release yet!")
  endif()
  # Disable all unsupported features and leave lines below for the future.
  set(ENABLE_SM2 Off CACHE BOOL "" FORCE)
  set(ENABLE_AEAD Off CACHE BOOL "" FORCE)
  set(ENABLE_TWOFISH Off CACHE BOOL "" FORCE)
  set(ENABLE_BRAINPOOL Off CACHE BOOL "" FORCE)
  # No SM2 support for OpenSSL yet.
  if (ENABLE_SM2)
    message(FATAL_ERROR "OpenSSL backend doesn't support SM2/SM3/SM4 algorithms yet.")
  endif()
  if (ENABLE_AEAD)
    message(FATAL_ERROR "OpenSSL backend doesn't support AEAD ciphers yet.")
  endif()
  set(CRYPTO_BACKEND_OPENSSL 1)
else()
  message(FATAL_ERROR "Invalid crypto backend: ${CRYPTO_BACKEND}")
endif()

# set warning flags at the top level
if(NOT MSVC)
  add_compile_options(
    -Wall -Wextra
    -Wunreachable-code -Wpointer-arith
    -Wmissing-declarations
  )
# relax some warnings a bit
  add_compile_options(
    -Wno-pedantic
    -Wno-ignored-qualifiers
    -Wno-unused-parameter
    -Wno-missing-field-initializers
  )
endif()

# MSYS-specific options
if(MSYS)
  add_compile_options(
    -fstack-protector
    -fopenmp
  )
  link_libraries(
    -fstack-protector
    -fopenmp
  )
endif()

# set a few other things at the top level to prevent incompatibilities
set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
add_definitions(-D_GNU_SOURCE)

if(MSVC_VERSION GREATER_EQUAL "1900")
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("/std:c++latest" _cpp_latest_flag_supported)
    if (_cpp_latest_flag_supported)
        add_compile_options("/std:c++latest")
    endif()
endif()

if (ENABLE_COVERAGE OR ENABLE_SANITIZERS)
  message("Forcing build type to Debug (for code coverage or sanitizers).")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Build type. Forced to Debug." FORCE)
endif()

# coverage
if (ENABLE_COVERAGE)
  if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    message(FATAL_ERROR "Coverage has only been tested with the GNU compiler.")
  endif()
  add_compile_options(--coverage -O0)
  link_libraries(--coverage)
endif()

# sanitizers
if (ENABLE_SANITIZERS)
  if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(FATAL_ERROR "Sanitizers have only been tested with the clang compiler.")
  endif()
  add_compile_options(-fsanitize=leak,address,undefined -fno-omit-frame-pointer -fno-common -O1)
  link_libraries(-fsanitize=leak,address,undefined)
endif()

# adoc for man generation
if (ENABLE_DOC)
  include(AdocMan)
endif()

# everything else is in subdirs
add_subdirectory(src/examples)
if (ENABLE_FUZZERS)
  add_subdirectory(src/fuzzing)
  add_compile_options(-DFUZZERS_ENABLED=1)
endif()
add_subdirectory(src/common)
add_subdirectory(src/lib)
add_subdirectory(src/rnp)
add_subdirectory(src/rnpkeys)

# build tests, if desired
if (BUILD_TESTING)
  # Googletest source path
  if (NOT GTEST_SOURCES)
    set(GTEST_SOURCES "" CACHE STRING
    "Path to the Googletest sources in case of download or linking to the precompiled library is disabled."
    FORCE
    )
  else()
    # Canonicalize path to the Googletest sources.
    get_filename_component(GTEST_SOURCES_FULL ${GTEST_SOURCES} REALPATH)
    set(GTEST_SOURCES ${GTEST_SOURCES_FULL})
  endif()
  add_subdirectory(src/tests)
endif()

# cpack packaging (RPM etc)
include(cmake/packaging.cmake)

=== debian/changelog ===
rnp (0.16.0-1) unstable; urgency=medium

  * New upstream version
  * drop patches applied upstream, refresh patches
  * clean up debian/TODO
  * update d/copyright
  * update symbols file

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 26 Mar 2022 13:58:06 -0400

=== debian/control ===
Source: rnp
Section: utils
Priority: optional
Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 asciidoctor <!nodoc>,
 cmake (>= 3.14),
 debhelper-compat (= 13),
 gnupg <!nocheck>,
 googletest <!nocheck>,
 libbotan-2-dev (>= 2.14.0),
 libbz2-dev,
 libjson-c-dev (>= 0.11),
 pkg-config,
 python3 <!nocheck>,
 python3-distutils <!nocheck>,
 zlib1g-dev,
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/debian/rnp.git
Vcs-Browser: https://salsa.debian.org/debian/rnp
Homepage: https://www.rnpgp.com/software/rnp/
Rules-Requires-Root: no

Package: rnp
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 librnp0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Cross-platform OpenPGP (RFC4880) tools (command-line tool)
 RNP is a set of cross-platform tools implementing OpenPGP (RFC 4880) and
 related standards.
 .
 This package contains the command-line tool, rnp.

Package: librnp0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Cross-platform OpenPGP (RFC4880) tools (library)
 RNP is a set of cross-platform tools implementing OpenPGP (RFC 4880) and
 related standards.
 .
 This package contains the shared library, librnp.

Package: librnp-dev
Section: libdevel
Architecture: any
Replaces: librnp-0-dev (<< 0.15.0)
Breaks: librnp-0-dev (<< 0.15.0)
Depends:
 librnp0 (= ${binary:Version}),
 ${misc:Depends},
Description: Cross-platform OpenPGP (RFC4880) tools (development files)
 RNP is a set of cross-platform tools implementing OpenPGP (RFC 4880) and
 related standards.
 .
 This package contains the development headers and documentation used
 to build other tools against the library.

## rnp 0.16.2

=== src/tests/CMakeLists.txt ===
# Copyright (c) 2018-2020 Ribose Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

if (BUILD_TESTING_GENERATORS)
  add_subdirectory(data/test_key_validity)
endif()

# fixture to copy the test data directory
add_test(
  NAME setupTestData
  COMMAND "${CMAKE_COMMAND}" -E copy_directory
          "${CMAKE_CURRENT_SOURCE_DIR}/data" "${CMAKE_CURRENT_BINARY_DIR}/data"
)
set_tests_properties(setupTestData PROPERTIES FIXTURES_SETUP testdata)

# rnp_tests
include(GoogleTest)
if (GTEST_SOURCES)
  # use Googletest sources if specified
  add_subdirectory(${GTEST_SOURCES}
    ${CMAKE_CURRENT_BINARY_DIR}/googletest-build
    EXCLUDE_FROM_ALL)
  set(GTestMain gtest_main)
elseif (NOT DOWNLOAD_GTEST)
  # use preinstalled googletest
  find_package(GTest REQUIRED)
  set(GTestMain GTest::Main)
else()
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL "4.8.5")
    set(GTEST_GIT_TAG "c43f710")
  else()
    set(GTEST_GIT_TAG "HEAD")
  endif()
  # download and build googletest
  include(FetchContent)
  FetchContent_Declare(googletest
    GIT_REPOSITORY  https://github.com/google/googletest.git
    GIT_TAG         "${GTEST_GIT_TAG}"
  )
  # maintain compiler/linker settings on Windows
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  # explicitly disable unneeded gmock build
  set(BUILD_GMOCK OFF CACHE BOOL "" FORCE)
  FetchContent_MakeAvailable(googletest)
  set(GTestMain gtest_main)
endif()

find_package(JSON-C 0.11 REQUIRED)
if (CRYPTO_BACKEND STREQUAL "botan")
  find_package(Botan2 2.14.0 REQUIRED)
endif()
if (CRYPTO_BACKEND STREQUAL "openssl")
  find_package(OpenSSL 1.1.1 REQUIRED)
endif()

add_executable(rnp_tests
  ../rnp/rnpcfg.cpp
  ../rnp/fficli.cpp
  ../rnp/rnp.cpp
  ../rnpkeys/rnpkeys.cpp
  ../rnpkeys/main.cpp
  ../rnpkeys/tui.cpp
  ../fuzzing/keyring.c
  ../fuzzing/keyring_g10.cpp
  ../fuzzing/keyring_kbx.c
  ../fuzzing/keyimport.c
  ../fuzzing/sigimport.c
  ../fuzzing/dump.c
  ../fuzzing/verify_detached.c
  ../fuzzing/verify.c
  cipher.cpp
  cipher_cxx.cpp
  cli.cpp
  exportkey.cpp
  ffi.cpp
  ffi-enc.cpp
  ffi-uid.cpp
  ffi-key-sig.cpp
  ffi-key-prop.cpp
  ffi-key.cpp
  file-utils.cpp
  generatekey.cpp
  kbx-nsigs-test.cpp
  key-add-userid.cpp
  key-grip.cpp
  key-prefs.cpp
  key-protect.cpp
  key-store-search.cpp
  key-unlock.cpp
  key-validate.cpp
  large-packet.cpp
  large-mpi.cpp
  load-g10.cpp
  load-pgp.cpp
  log-switch.cpp
  partial-length.cpp
  pipe.cpp
  rnp_tests.cpp
  rng-randomness.cpp
  s2k-iterations.cpp
  streams.cpp
  support.cpp
  user-prefs.cpp
  utils-hex2bin.cpp
  utils-rnpcfg.cpp
  issues/1030.cpp
  issues/1115.cpp
  issues/1171.cpp
  issues/oss-fuzz-25489.cpp
  fuzz_keyring.cpp
  fuzz_keyring_g10.cpp
  fuzz_keyring_kbx.cpp
  fuzz_keyimport.cpp
  fuzz_sigimport.cpp
  fuzz_dump.cpp
  fuzz_verify_detached.cpp
  fuzz_verify.cpp
)
if(MSVC)
  find_package(WindowsSDK)
  GetUMWindowsSDKLibraryDir(WIN_LIBRARY_DIR)
  message (STATUS "WIN_LIBRARY_DIR: ${WIN_LIBRARY_DIR}")
  find_library(SHLWAPI_LIBRARY
    PATHS
       ${WIN_LIBRARY_DIR}
    NAMES shlwapi)

  find_path(GETOPT_INCLUDE_DIR
    NAMES getopt.h
  )
  find_library(GETOPT_LIBRARY
    NAMES getopt
  )
  find_path(DIRENT_INCLUDE_DIR
    NAMES dirent.h
  )
  target_include_directories(rnp_tests
    PRIVATE
      "${GETOPT_INCLUDE_DIR}"
      "${DIRENT_INCLUDE_DIR}"
    )
  target_link_libraries(rnp_tests
    PRIVATE
      "${SHLWAPI_LIBRARY}"
      "${GETOPT_LIBRARY}"
    )
endif()
target_include_directories(rnp_tests
  PRIVATE
    "${PROJECT_SOURCE_DIR}/src"
    "${PROJECT_SOURCE_DIR}/src/lib"
    "${BOTAN2_INCLUDE_DIRS}"
)
target_link_libraries(rnp_tests
  PRIVATE
    librnp-static
    JSON-C::JSON-C
    ${GTestMain}
)
if (CRYPTO_BACKEND STREQUAL "openssl")
  target_link_libraries(rnp_tests PRIVATE OpenSSL::Crypto)
endif()
if (WIN32 AND (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
  target_link_libraries(rnp_tests PRIVATE regex)
elseif(MSVC)
  add_compile_definitions(RNP_USE_STD_REGEX)
endif()
target_compile_definitions(rnp_tests
  PRIVATE
    RNP_RUN_TESTS
    RNP_STATIC
)

# Centos 7 with CLang 7.0.1 reports strange memory leak in GoogleTest, maybe there is a better solution
if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7.0.1)
  set_target_properties(rnp_tests PROPERTIES CXX_VISIBILITY_PRESET hidden)
endif()

gtest_discover_tests(rnp_tests
  PROPERTIES
    FIXTURES_REQUIRED testdata
    TIMEOUT 3000
    ENVIRONMENT "RNP_TEST_DATA=${CMAKE_CURRENT_SOURCE_DIR}/data"
)

# ruby-rnp
# cruby does not currently play nice with ASaN et al.
if (DOWNLOAD_RUBYRNP AND NOT ENABLE_SANITIZERS AND BUILD_SHARED_LIBS AND NOT WIN32)
  include(ExternalProject)
  set(_sourcedir "${CMAKE_BINARY_DIR}/ruby-rnp")
  if (DEFINED ENV{RUBY_RNP_INSTALL})
    set(_sourcedir "$ENV{RUBY_RNP_INSTALL}")
  endif()
  set(_ruby_rnp_ver "main")
  if (DEFINED ENV{RUBY_RNP_VERSION})
    set(_ruby_rnp_ver "$ENV{RUBY_RNP_VERSION}")
  endif()
  ExternalProject_Add(ruby-rnp
    GIT_REPOSITORY https://github.com/rnpgp/ruby-rnp.git
    GIT_TAG "${_ruby_rnp_ver}"
    GIT_SHALLOW yes
    SOURCE_DIR "${_sourcedir}"
    BUILD_IN_SOURCE yes
    CONFIGURE_COMMAND ""
    BUILD_COMMAND
      COMMAND bundle add ffi --version 1.15.5
      COMMAND bundle show parallel_tests || bundle add parallel_tests
      COMMAND bundle install --path .
    INSTALL_COMMAND ""
    TEST_COMMAND ""
  )
  set(_env "CI=false")
  if (WIN32)
    list(APPEND _env "PATH=$<TARGET_LINKER_FILE_DIR:librnp>\;$ENV{PATH}")
  else()
    list(APPEND _env "LD_LIBRARY_PATH=$<TARGET_LINKER_FILE_DIR:librnp>:$ENV{LD_LIBRARY_PATH}")
  endif()
  add_test(
    NAME ruby-rnp
    WORKING_DIRECTORY "${_sourcedir}"
    COMMAND bundle exec parallel_rspec spec/
  )
  set_tests_properties(ruby-rnp PROPERTIES
    TIMEOUT 1000
    ENVIRONMENT "${_env}"
  )
endif()

# cli_tests
# Note that we do this call early because Google Test will also do
# this but with less strict version requirements, which will cause
# problems for us.
find_package(Python3 COMPONENTS Interpreter)
find_package(GnuPG 2.2 COMPONENTS gpg gpgconf)
function(add_cli_test suite)
  set(_test_name cli_tests-${suite})
  add_test(
    NAME ${_test_name}
    COMMAND "${Python3_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/cli_tests.py" -v -d "${suite}"
  )
  set(_env)
  list(APPEND _env
    "RNP_TESTS_RNP_PATH=$<TARGET_FILE:rnp>"
    "RNP_TESTS_RNPKEYS_PATH=$<TARGET_FILE:rnpkeys>"
    "RNP_TESTS_GPG_PATH=${GPG_EXECUTABLE}"
    "RNP_TESTS_GPGCONF_PATH=${GPGCONF_EXECUTABLE}"
  )
  set_tests_properties(${_test_name} PROPERTIES
    TIMEOUT 3000
    FIXTURES_REQUIRED testdata
    ENVIRONMENT "${_env}"
  )
endfunction()
# get a list of test suites
execute_process(
  COMMAND "${Python3_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/cli_tests.py" -ls
  RESULT_VARIABLE _ec
  OUTPUT_VARIABLE suitelist
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
if (NOT _ec EQUAL 0)
  message(FATAL_ERROR "Failed to retrieve test suite list for cli_tests")
endif()
# convert to a CMake list
string(REGEX REPLACE ";" "\\\\;" suitelist "${suitelist}")
string(REGEX REPLACE "\n" ";" suitelist "${suitelist}")
# create a CTest test for each suite
foreach(suite IN LISTS suitelist)
  add_cli_test("${suite}")
endforeach()

=== debian/changelog ===
rnp (0.16.2-1mx21+1) mx; urgency=medium

  * Rebuild for MX-21.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 12 Nov 2022 13:47:36 -0800

rnp (0.16.2-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 03 Oct 2022 21:30:25 -0400

rnp (0.16.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: bump to 4.6.1 (no changes needed)
  * clean up lintian overrides
  * update symbols file

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 09 Sep 2022 19:02:09 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: rnp
 Section: utils
 Priority: optional
-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
  asciidoctor <!nodoc>,
  cmake (>= 3.14),
@@ -15,7 +16,7 @@
  python3 <!nocheck>,
  python3-distutils <!nocheck>,
  zlib1g-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/debian/rnp.git
 Vcs-Browser: https://salsa.debian.org/debian/rnp
 Homepage: https://www.rnpgp.com/software/rnp/

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -DS2K_MINIMUM_TUNING_RATIO=4

ifneq (,$(filter $(DEB_HOST_ARCH), s390x))
export DEB_CXXFLAGS_MAINT_APPEND = -DS2K_MINIMUM_TUNING_RATIO=1.5
endif

CONFIGURE_OPTIONS = -DBUILD_SHARED_LIBS=on \
     -DDOWNLOAD_GTEST=off \
     -DGTEST_SOURCES=/usr/src/googletest \
     -DDOWNLOAD_RUBYRNP=off

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
CONFIGURE_OPTIONS += -DBUILD_TESTING=off
endif

ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
CONFIGURE_OPTIONS += -DENABLE_DOC=off
else
CONFIGURE_OPTIONS += -DENABLE_DOC=on
endif

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build -- $(CONFIGURE_OPTIONS)

%:
	dh $@ --builddirectory=build

override_dh_strip:
	dh_strip -a --no-automatic-dbgsym

## rnp 0.16.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,6 +49,9 @@
   DESCRIPTION "${PACKAGE_DESCRIPTION_SHORT}"
 )
 
+# tri-state options
+set(TRISTATE_VALUES On Off Auto)
+
 # options
 option(ENABLE_COVERAGE "Enable code coverage testing.")
 option(ENABLE_SANITIZERS "Enable ASan and other sanitizers.")
@@ -56,13 +59,16 @@
 option(DOWNLOAD_GTEST "Download Googletest" On)
 option(DOWNLOAD_RUBYRNP "Download ruby-rnp and run related tests." On)
 # crypto components
-option(ENABLE_SM2 "Enable SM2/SM3/SM4 algorithms support." On)
-option(ENABLE_AEAD "Enable AEAD ciphers support." On)
-option(ENABLE_TWOFISH "Enable Twofish cipher support." On)
-option(ENABLE_BRAINPOOL "Enable Brainpool curves support." On)
-
-# tri-state options
-set(TRISTATE_VALUES On Off Auto)
+set(ENABLE_SM2 Auto CACHE STRING "Enable SM2/SM3/SM4 algorithms support.")
+set_property(CACHE ENABLE_SM2 PROPERTY STRINGS ${TRISTATE_VALUES})
+set(ENABLE_AEAD Auto CACHE STRING "Enable AEAD ciphers support.")
+set_property(CACHE ENABLE_AEAD PROPERTY STRINGS ${TRISTATE_VALUES})
+set(ENABLE_TWOFISH Auto CACHE STRING "Enable Twofish cipher support.")
+set_property(CACHE ENABLE_TWOFISH PROPERTY STRINGS ${TRISTATE_VALUES})
+set(ENABLE_BRAINPOOL Auto CACHE STRING "Enable Brainpool curves support.")
+set_property(CACHE ENABLE_BRAINPOOL PROPERTY STRINGS ${TRISTATE_VALUES})
+set(ENABLE_IDEA Auto CACHE STRING "Enable IDEA algorithm support.")
+set_property(CACHE ENABLE_IDEA PROPERTY STRINGS ${TRISTATE_VALUES})
 
 set(ENABLE_DOC Auto CACHE STRING "Enable building documentation.")
 set_property(CACHE ENABLE_DOC PROPERTY STRINGS ${TRISTATE_VALUES})
@@ -92,22 +98,6 @@
   # Default value;
   set(CRYPTO_BACKEND_BOTAN 1)
 elseif(CRYPTO_BACKEND STREQUAL "openssl")
-  # Do not allow OpenSSL backend in release builds yet.
-  if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
-    message(WARNING "OpenSSL backend should be used only at debug mode and not ready for release yet!")
-  endif()
-  # Disable all unsupported features and leave lines below for the future.
-  set(ENABLE_SM2 Off CACHE BOOL "" FORCE)
-  set(ENABLE_AEAD Off CACHE BOOL "" FORCE)
-  set(ENABLE_TWOFISH Off CACHE BOOL "" FORCE)
-  set(ENABLE_BRAINPOOL Off CACHE BOOL "" FORCE)
-  # No SM2 support for OpenSSL yet.
-  if (ENABLE_SM2)
-    message(FATAL_ERROR "OpenSSL backend doesn't support SM2/SM3/SM4 algorithms yet.")
-  endif()
-  if (ENABLE_AEAD)
-    message(FATAL_ERROR "OpenSSL backend doesn't support AEAD ciphers yet.")
-  endif()
   set(CRYPTO_BACKEND_OPENSSL 1)
 else()
   message(FATAL_ERROR "Invalid crypto backend: ${CRYPTO_BACKEND}")
@@ -147,14 +137,6 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 add_definitions(-D_GNU_SOURCE)
-
-if(MSVC_VERSION GREATER_EQUAL "1900")
-    include(CheckCXXCompilerFlag)
-    CHECK_CXX_COMPILER_FLAG("/std:c++latest" _cpp_latest_flag_supported)
-    if (_cpp_latest_flag_supported)
-        add_compile_options("/std:c++latest")
-    endif()
-endif()
 
 if (ENABLE_COVERAGE OR ENABLE_SANITIZERS)
   message("Forcing build type to Debug (for code coverage or sanitizers).")

=== src/lib/CMakeLists.txt ===
# Copyright (c) 2018-2020 Ribose Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

include(GNUInstallDirs)
include(GenerateExportHeader)

# these could probably be optional but are currently not
find_package(BZip2 REQUIRED)
find_package(ZLIB REQUIRED)

# required packages
find_package(JSON-C 0.11 REQUIRED)
if (CRYPTO_BACKEND_BOTAN)
  find_package(Botan2 2.14.0 REQUIRED)
endif()
if (CRYPTO_BACKEND_OPENSSL)
  include(FindOpenSSL)
  find_package(OpenSSL 1.1.1 REQUIRED)
  include(FindOpenSSLFeatures)
  if("${OPENSSL_VERSION}" VERSION_GREATER_EQUAL "3.0.0")
    set(CRYPTO_BACKEND_OPENSSL3 1)
  endif()
endif()

# generate a config.h
include(CheckIncludeFileCXX)
include(CheckCXXSymbolExists)
check_include_file_cxx(fcntl.h HAVE_FCNTL_H)
check_include_file_cxx(inttypes.h HAVE_INTTYPES_H)
check_include_file_cxx(limits.h HAVE_LIMITS_H)
check_include_file_cxx(stdint.h HAVE_STDINT_H)
check_include_file_cxx(string.h HAVE_STRING_H)
check_include_file_cxx(sys/cdefs.h HAVE_SYS_CDEFS_H)
check_include_file_cxx(sys/cdefs.h HAVE_SYS_MMAN_H)
check_include_file_cxx(sys/resource.h HAVE_SYS_RESOURCE_H)
check_include_file_cxx(sys/stat.h HAVE_SYS_STAT_H)
check_include_file_cxx(sys/types.h HAVE_SYS_TYPES_H)
check_include_file_cxx(sys/param.h HAVE_SYS_PARAM_H)
check_include_file_cxx(unistd.h HAVE_UNISTD_H)
check_include_file_cxx(sys/wait.h HAVE_SYS_WAIT_H)
check_cxx_symbol_exists(mkdtemp "stdlib.h;unistd.h" HAVE_MKDTEMP)
check_cxx_symbol_exists(mkstemp "stdlib.h;unistd.h" HAVE_MKSTEMP)
check_cxx_symbol_exists(realpath stdlib.h HAVE_REALPATH)
check_cxx_symbol_exists(O_BINARY fcntl.h HAVE_O_BINARY)
check_cxx_symbol_exists(_O_BINARY fcntl.h HAVE__O_BINARY)
check_cxx_symbol_exists(_tempnam stdio.h HAVE__TEMPNAM)
set(HAVE_ZLIB_H "${ZLIB_FOUND}")
set(HAVE_BZLIB_H "${BZIP2_FOUND}")
# generate a version.h
configure_file(version.h.in version.h)

# Checks feature in CRYPTO_BACKEND and puts the result into variable whose name is stored in RESULT_VARNAME variable.
function(backend_has_feature FEATURE RESULT_VARNAME)
  if (CRYPTO_BACKEND STREQUAL "botan")
    check_cxx_symbol_exists("BOTAN_HAS_${FEATURE}" botan/build.h ${RESULT_VARNAME})
  else()
  message(STATUS "Looking for OpenSSL feature ${FEATURE}")
    OpenSSLHasFeature(${FEATURE} ${RESULT_VARNAME})
    if (${RESULT_VARNAME})
      message(STATUS "Looking for OpenSSL feature ${FEATURE} - found")
    endif()
    set(${RESULT_VARNAME} "${${RESULT_VARNAME}}" PARENT_SCOPE)
  endif()
endfunction()

function(resolve_feature_state RNP_FEATURE BACKEND_FEATURES)
  if (NOT ${RNP_FEATURE}) # User has explicitly disabled this feature
    return()
  endif()

  string(TOLOWER "${${RNP_FEATURE}}" ${RNP_FEATURE})
  if (${RNP_FEATURE} STREQUAL "auto")
    set(MESSAGE_TYPE "NOTICE")
    set(OUTCOME "Disabling")
  else() # User has explicitly enabled this feature
    set(MESSAGE_TYPE "FATAL_ERROR")
    set(OUTCOME "Aborting")
  endif()

  foreach(feature ${BACKEND_FEATURES})
    backend_has_feature("${feature}" _has_${feature})
    if (NOT ${_has_${feature}})
      set(${RNP_FEATURE} Off CACHE STRING "Autodetected" FORCE)
      message(${MESSAGE_TYPE} "${RNP_FEATURE} requires ${CRYPTO_BACKEND} feature which is missing: ${feature}. ${OUTCOME}.")
      return()
    endif()
  endforeach()
  set(${RNP_FEATURE} On CACHE STRING "Autodetected" FORCE)
endfunction()

function(openssl_nope RNP_FEATURE REASON)
  if (NOT ${RNP_FEATURE}) # User has explicitly disabled this feature
    return()
  endif()

  string(TOLOWER "${${RNP_FEATURE}}" ${RNP_FEATURE})
  if (${RNP_FEATURE} STREQUAL "auto")
    set(MESSAGE_TYPE "NOTICE")
    set(OUTCOME "Disabling")
  else() # User has explicitly enabled this feature
    set(MESSAGE_TYPE "FATAL_ERROR")
    set(OUTCOME "Aborting")
  endif()

  set(${RNP_FEATURE} Off CACHE STRING "Auto -> Off as no support" FORCE)
  message(${MESSAGE_TYPE} "${RNP_FEATURE} doesn't work with OpenSSL backend (${REASON}). ${OUTCOME}.")
endfunction()

if(CRYPTO_BACKEND_BOTAN)
  # check botan's enabled features
  set(CMAKE_REQUIRED_INCLUDES "${BOTAN2_INCLUDE_DIRS}")
  set(_botan_required_features
      # base
      BIGINT FFI HEX_CODEC PGP_S2K
      # symmetric ciphers
      BLOCK_CIPHER AES BLOWFISH CAMELLIA CAST_128 DES
      # cipher modes
      MODE_CBC MODE_CFB
      # RNG
      AUTO_RNG AUTO_SEEDING_RNG HMAC HMAC_DRBG
      # hash
      CRC24 HASH MD5 SHA1 SHA2_32 SHA2_64 SHA3 RIPEMD_160
      # public-key core
      DL_GROUP DL_PUBLIC_KEY_FAMILY ECC_GROUP ECC_PUBLIC_KEY_CRYPTO PUBLIC_KEY_CRYPTO
      # public-key algs
      CURVE_25519 DSA ECDH ECDSA ED25519 ELGAMAL RSA
      # public-key operations etc
      EME_PKCS1v15 EMSA_PKCS1 EMSA_RAW KDF_BASE RFC3394_KEYWRAP SP800_56A
  )
  foreach(feature ${_botan_required_features})
    check_cxx_symbol_exists("BOTAN_HAS_${feature}" botan/build.h _botan_has_${feature})
    if (NOT _botan_has_${feature})
      message(FATAL_ERROR "A required botan feature is missing: ${feature}")
    endif()
  endforeach()

  resolve_feature_state(ENABLE_SM2 "SM2;SM3;SM4")
  resolve_feature_state(ENABLE_AEAD "AEAD_EAX;AEAD_OCB")
  resolve_feature_state(ENABLE_TWOFISH "TWOFISH")
  resolve_feature_state(ENABLE_IDEA "IDEA")
  # Botan supports Brainpool curves together with SECP via the ECC_GROUP define
  set(CMAKE_REQUIRED_INCLUDES)
endif()
if(CRYPTO_BACKEND_OPENSSL)
  # check OpenSSL features
  set(_openssl_required_features
    # symmetric ciphers
    AES-128-ECB AES-192-ECB AES-256-ECB AES-128-CBC AES-192-CBC AES-256-CBC
    BF-ECB CAMELLIA-128-ECB CAMELLIA-192-ECB CAMELLIA-256-ECB CAST5-ECB
    DES-EDE3
    # hashes
    MD5 SHA1 SHA224 SHA256 SHA384 SHA512 SHA3-256 SHA3-512 RIPEMD160
    # curves
    PRIME256V1 SECP384R1 SECP521R1 SECP256K1
    # public key
    RSAENCRYPTION DSAENCRYPTION DHKEYAGREEMENT ID-ECPUBLICKEY X25519 ED25519
  )
  foreach(feature ${_openssl_required_features})
    message(STATUS "Looking for OpenSSL feature ${feature}")
    OpenSSLHasFeature("${feature}" _openssl_has_${feature})
    if (NOT _openssl_has_${feature})
      message(FATAL_ERROR "A required OpenSSL feature is missing: ${feature}")
    endif()
    message(STATUS "Looking for OpenSSL feature ${feature} - found")
  endforeach()

  resolve_feature_state(ENABLE_BRAINPOOL "BRAINPOOLP256R1;BRAINPOOLP384R1;BRAINPOOLP512R1")
  resolve_feature_state(ENABLE_IDEA "IDEA-ECB;IDEA-CBC")
  openssl_nope(ENABLE_SM2 "it's on our roadmap, see https://github.com/rnpgp/rnp/issues/1877")
  #resolve_feature_state(ENABLE_SM2 "SM2;SM3;SM4-ECB")
  openssl_nope(ENABLE_TWOFISH "Twofish isn't and won't be supported by OpenSSL, see https://github.com/openssl/openssl/issues/2046")
  openssl_nope(ENABLE_AEAD "it's on our roadmap, see https://github.com/rnpgp/rnp/issues/1642")
endif()

configure_file(config.h.in config.h)

if(CRYPTO_BACKEND_OPENSSL)
  set(CRYPTO_SOURCES
    crypto/bn_ossl.cpp
    crypto/dsa_ossl.cpp
    crypto/ec_curves.cpp
    crypto/ec_ossl.cpp
    crypto/ecdh_utils.cpp
    crypto/ecdh_ossl.cpp
    crypto/ecdsa_ossl.cpp
    crypto/eddsa_ossl.cpp
    crypto/dl_ossl.cpp
    crypto/elgamal_ossl.cpp
    crypto/hash_common.cpp
    crypto/hash_ossl.cpp
    crypto/hash_crc24.cpp
    crypto/mpi.cpp
    crypto/rng_ossl.cpp
    crypto/rsa_ossl.cpp
    crypto/s2k.cpp
    crypto/s2k_ossl.cpp
    crypto/symmetric_ossl.cpp
    crypto/signatures.cpp
    crypto/mem_ossl.cpp
    crypto/cipher.cpp
    crypto/cipher_ossl.cpp
  )
  if(ENABLE_SM2)
    list(APPEND CRYPTO_SOURCES crypto/sm2_ossl.cpp)
  endif()
elseif(CRYPTO_BACKEND_BOTAN)
  set(CRYPTO_SOURCES
    crypto/bn.cpp
    crypto/dsa.cpp
    crypto/ec_curves.cpp
    crypto/ec.cpp
    crypto/ecdh_utils.cpp
    crypto/ecdh.cpp
    crypto/ecdsa.cpp
    crypto/eddsa.cpp
    crypto/elgamal.cpp
    crypto/hash_common.cpp
    crypto/hash.cpp
    crypto/mpi.cpp
    crypto/rng.cpp
    crypto/rsa.cpp
    crypto/s2k.cpp
    crypto/symmetric.cpp
    crypto/signatures.cpp
    crypto/mem.cpp
    crypto/cipher.cpp
    crypto/cipher_botan.cpp
  )
  if(ENABLE_SM2)
    list(APPEND CRYPTO_SOURCES crypto/sm2.cpp)
  endif()
else()
  message(FATAL_ERROR "Unknown crypto backend: ${CRYPTO_BACKEND}.")
endif()
list(APPEND CRYPTO_SOURCES crypto/backend_version.cpp)

# sha11collisiondetection sources
list(APPEND CRYPTO_SOURCES crypto/hash_sha1cd.cpp crypto/sha1cd/sha1.c crypto/sha1cd/ubc_check.c)

add_library(librnp-obj OBJECT
  # librepgp
  ../librepgp/stream-armor.cpp
  ../librepgp/stream-common.cpp
  ../librepgp/stream-ctx.cpp
  ../librepgp/stream-dump.cpp
  ../librepgp/stream-key.cpp
  ../librepgp/stream-packet.cpp
  ../librepgp/stream-parse.cpp
  ../librepgp/stream-sig.cpp
  ../librepgp/stream-write.cpp

  # librekey
  ../librekey/key_store_g10.cpp
  ../librekey/key_store_kbx.cpp
  ../librekey/key_store_pgp.cpp
  ../librekey/rnp_key_store.cpp

  # cryptography
  ${CRYPTO_SOURCES}

  # other sources
  sec_profile.cpp
  crypto.cpp
  fingerprint.cpp
  generate-key.cpp
  key-provider.cpp
  logging.cpp
  json-utils.cpp
  utils.cpp
  pass-provider.cpp
  pgp-key.cpp
  rnp.cpp
  $<TARGET_OBJECTS:rnp-common>
)

get_target_property(_comp_options librnp-obj COMPILE_OPTIONS)
string(REGEX MATCH "\\-fsanitize=[a-z,]*undefined" _comp_sanitizers "${_comp_options}" "${CMAKE_C_FLAGS}")
if (ENABLE_SANITIZERS OR _comp_sanitizers)
  # sha1cd attempts to use unaligned access for optimisations on intel CPUs
  # CFLAGS is checked as sanitizers may be enabled without CMake var
  set_source_files_properties(crypto/sha1cd/sha1.c
    PROPERTIES COMPILE_DEFINITIONS "SHA1DC_FORCE_ALIGNED_ACCESS"
  )
endif()

set_target_properties(librnp-obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_include_directories(librnp-obj
  PUBLIC
    "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src/lib>"
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/common>"
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
    "$<INSTALL_INTERFACE:include>"
  PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${PROJECT_SOURCE_DIR}/src"
)
target_link_libraries(librnp-obj PRIVATE JSON-C::JSON-C)
if (CRYPTO_BACKEND_BOTAN)
  target_link_libraries(librnp-obj PRIVATE Botan2::Botan2)
elseif (CRYPTO_BACKEND_OPENSSL)
  target_link_libraries(librnp-obj PRIVATE OpenSSL::Crypto)
endif()

set_target_properties(librnp-obj PROPERTIES CXX_VISIBILITY_PRESET hidden)
if (TARGET BZip2::BZip2)
  target_link_libraries(librnp-obj PRIVATE BZip2::BZip2)
endif()
if (TARGET ZLIB::ZLIB)
  target_link_libraries(librnp-obj PRIVATE ZLIB::ZLIB)
endif()
if (BUILD_SHARED_LIBS)
  target_compile_definitions(librnp-obj PRIVATE librnp_EXPORTS)
else()
  target_compile_definitions(librnp-obj PRIVATE RNP_STATIC)
endif()

add_library(librnp $<TARGET_OBJECTS:librnp-obj> $<TARGET_OBJECTS:rnp-common>)
set_target_properties(librnp
  PROPERTIES
    VERSION "${RNP_VERSION}"
    SOVERSION "${RNP_VERSION_MAJOR}"
    PREFIX "lib"

=== src/rnp/CMakeLists.txt ===
# Copyright (c) 2018-2020 Ribose Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

if(MSVC)
  # remove extra ${Configuration} subfolder
  set(ArchiveOutputDir ${CMAKE_BINARY_DIR}\\src\\rnp)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG ${ArchiveOutputDir})
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_MINSIZEREL ${ArchiveOutputDir})
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${ArchiveOutputDir})
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO ${ArchiveOutputDir})

  set(RuntimeOutputDir ${CMAKE_BINARY_DIR}\\src\\rnp)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${RuntimeOutputDir})
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${RuntimeOutputDir})
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${RuntimeOutputDir})
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${RuntimeOutputDir})

  find_path(GETOPT_INCLUDE_DIR
    NAMES getopt.h
  )
  find_library(GETOPT_LIBRARY
    NAMES getopt
  )
  find_path(DIRENT_INCLUDE_DIR
    NAMES dirent.h
  )
endif()

# for the headers
find_package(JSON-C 0.11 REQUIRED)

add_executable(rnp
  rnp.cpp
  fficli.cpp
  ../rnpkeys/tui.cpp
  ../lib/logging.cpp
  rnpcfg.cpp
  $<TARGET_OBJECTS:rnp-common>
)

target_include_directories(rnp
  PRIVATE
    "${PROJECT_SOURCE_DIR}/src"
    "${PROJECT_SOURCE_DIR}/src/lib"
    "${JSON-C_INCLUDE_DIRS}"
)
if(MSVC)
  target_include_directories(rnp
    PRIVATE
      "${GETOPT_INCLUDE_DIR}"
      "${DIRENT_INCLUDE_DIR}"
    )
endif()

target_link_libraries(rnp
  PRIVATE
    librnp
    JSON-C::JSON-C
)
if(MSVC)
  target_link_libraries(rnp
    PRIVATE
      "${GETOPT_LIBRARY}"
    )
endif()

if(WIN32 AND (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
  target_link_libraries(rnp PRIVATE regex)
elseif(MSVC)
  add_compile_definitions(RNP_USE_STD_REGEX)
endif()

include(GNUInstallDirs)
install(TARGETS rnp
  RUNTIME
    DESTINATION "${CMAKE_INSTALL_BINDIR}"
    COMPONENT cli
)

# Build and install man page
if (ENABLE_DOC)
  add_adoc_man("${CMAKE_CURRENT_SOURCE_DIR}/rnp.1.adoc" ${RNP_VERSION})
endif()

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -222,11 +222,11 @@
     GIT_SHALLOW yes
     SOURCE_DIR "${_sourcedir}"
     BUILD_IN_SOURCE yes
-    CONFIGURE_COMMAND ""
+    CONFIGURE_COMMAND bundle config set --local path '.'
     BUILD_COMMAND
       COMMAND bundle add ffi --version 1.15.5
       COMMAND bundle show parallel_tests || bundle add parallel_tests
-      COMMAND bundle install --path .
+      COMMAND bundle install
     INSTALL_COMMAND ""
     TEST_COMMAND ""
   )

=== debian/changelog ===
rnp (0.16.3-1) unstable; urgency=medium

  * New upstream release, Closes: #1034558
    - Fixes CVE-2023-29479
    - Fixes CVE-2023-29480
  * standards-version: bump to 4.6.2 (no changes needed)
  * drop unnecessary lintian overrides
  * d/copyright: include 2023

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 24 May 2023 09:06:07 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: rnp
 Section: utils
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
  asciidoctor <!nodoc>,
  cmake (>= 3.14),
@@ -16,7 +15,7 @@
  python3 <!nocheck>,
  python3-distutils <!nocheck>,
  zlib1g-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/debian/rnp.git
 Vcs-Browser: https://salsa.debian.org/debian/rnp
 Homepage: https://www.rnpgp.com/software/rnp/

=== debian/rules ===
--- 
+++ 
@@ -30,6 +30,3 @@
 
 %:
 	dh $@ --builddirectory=build
-
-override_dh_strip:
-	dh_strip -a --no-automatic-dbgsym
